package dont.know.RockCrawler;
import android.app.Activity;
import android.content.pm.ActivityInfo;
import android.os.Bundle;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnTouchListener;
import android.view.WindowManager;
import android.widget.TextView;
import at.abraxas.amarino.Amarino;


public class RockCrawlerActivity extends Activity implements OnTouchListener {
	
	TouchProcess tpro;
	//private static final String TAG = "RockCrawlerActivivity";
	private static final String address = "00:11:11:25:09:23";	//bt module on bot
	//private static final String address = "00:11:05:09:03:39";	//bt module in lab
	final int DELAY = 120;	// orig:150
	static final char flag = 'a'; //0x61
	int scr_x, scr_y;
	short ss, st;
	TextView textView;
	TextView textView2;
	View touchView;
	boolean touched = false;
	long t1;
	char[] tmp = new char[3];

	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
		Amarino.connect(this, address);
        textView = (TextView)findViewById(R.id.textView1);
        textView2 = (TextView)findViewById(R.id.textView2);
        
        // this is the view on which you will listen for touch events
        touchView = findViewById(R.id.touchView);
        touchView.setOnTouchListener(this);
        
      //added these
        setRequestedOrientation(
        		ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        getWindow().setFlags(
        		WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON,
        		WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON
        		);
        
        
        t1 = System.currentTimeMillis();
       tpro = new TouchProcess();
        //tpro = new TouchProcess(((int)touchView.getMeasuredWidth()), ((int)touchView.getMeasuredHeight()));
        tpro.center();
        
    }
    
    

    @Override
    protected void onPause() {
        super.onPause();
        tpro.center();
		Amarino.sendDataToArduino( this, address, flag, tpro.outBuf);

    }// end pause
    
    
	@Override
	protected void onStop() {
		super.onStop();
		
        tpro.center();
		Amarino.sendDataToArduino( this, address, flag, tpro.outBuf);

		Amarino.disconnect(this, address);
	}// on stop
    
    
    @Override
    protected void onResume() {
        super.onResume();
        tpro.center();
        
    }//end resume



	@Override
	public boolean onTouch(View v, MotionEvent event) {
		tpro.setDem(v.getWidth(), v.getHeight());
		
		
		scr_x = (int)event.getX();
		scr_y = (int)event.getY();
	
		//ss = tpro.unsBytetoShort(tpro.outBuf[0]);
		//st = tpro.unsBytetoShort(tpro.outBuf[1]);
		
		textView.setText("Touch coordinates : " +
                //String.valueOf(tpro.width)+ " "+String.valueOf(tpro.height));
				String.valueOf(scr_x) + "x" + String.valueOf(scr_y));
		
		textView2.setText("Last Sent: ["+ Integer.toHexString((int)tpro.outBuf[0])+"] - ["+
				Integer.toString((int)tpro.outBuf[0])+"] - ["+Integer.toString((int)tpro.outBuf[1])+"]");
		
		switch(event.getAction()){
		case MotionEvent.ACTION_DOWN:
			touched = true;
			break;
		case MotionEvent.ACTION_MOVE:
			if(touched && ((System.currentTimeMillis()-t1)>DELAY)){
				t1 = System.currentTimeMillis();
				tpro.processT(scr_x, scr_y);				
				//tpro.outBuf[0] = (byte)0x63;
				//tpro.outBuf[1] = (byte)0x66;
				//tpro.outBuf[2] = (byte)0x68;
				
				//Amarino.sendDataToArduino( this, address, flag, tmp);
				Amarino.sendDataToArduino( this, address, flag, tpro.outBuf);
			}
			break;
		case MotionEvent.ACTION_UP:
			touched = false;
			tpro.center();
			//Amarino.sendDataToArduino( this, address, flag, tpro.outBuf);
			break;
		}

		
		return true;
	}



  
    
}// end activity