package dont.know.RockCrawler;

public class TouchProcess {
	public char[] outBuf = new char[3];
    //public char outBuf[0];
    static final int x_b = 10;
    static final int y_b = 25;
    public int width, height;
    
    TouchProcess(){
    	outBuf[0] = 0x40;	//steering pos
    	outBuf[1] = 0x01;		// steering val, should be 0, set to 1 for test
    	outBuf[2] = 0x50;	//80=0x50, 0=0, 180=B4, drive vel.
    	//outBuf[3] = (char)0x70;	// end char 0x70='p'
    }
    
    public void setDem(int w, int h){
    	width = w;
    	height = h;
    }
    
    public void center(){
    	outBuf[0] = 0x40;
    	outBuf[1] = 0;
    	outBuf[2] = 0x50;	//80=0x50, 0=0, 180=B4
    }
    
    public void processT(int x, int y){
    	if(x<(width/2-x_b)){
    		outBuf[0] = 0x30;	//left
    		outBuf[1] = (char)(100-mapV(x, 0, (width/2-x_b), 0, 100));
    	}
    	else if(x>(width/2+x_b)){
    		outBuf[0] = 0x50;	//right
    		outBuf[1] = (char)mapV(x, (width/2-x_b), width, 0, 100);
    	}
    	else{
    		outBuf[0] = 0x40;	//center
    		outBuf[1] = 0;
    	}
    	
    	if(y<(height/2-y_b)){
    		outBuf[2] = (char)mapV(y, 0, (height/2-y_b), 0, 80);	// forward
    	}
    	else if(y>(height/2+y_b)){
    		outBuf[2] = (char)mapV(y, (height/2+y_b), height, 80, 180);	// backward
    	}
    	else
    		outBuf[2] = 0x50;	//stopped
    }
    
    public int mapV(int x, int in_min, int in_max, int out_min, int out_max)
    {
      return (x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min;
    }
    
    public short unsBytetoShort(byte b){
    	return ( (short)(b & 0xff) );
    }

}
